<template>
  <div class="overview">
    <!-- Resource Configuration -->
    <b-card class="my-2">
      <b-link class="float-end text-primary" @click.prevent="toTab(tabs[0])">
        {{ $t("page.createResource.overview.edit") }}
      </b-link>
      <CoscineHeadline :headline="$t('form.steps.first')" h="h5" />

      <CoscineFormGroup
        v-if="resourceForCreation && resourceForCreation.resourceTypeOptions"
        :mandatory="true"
        :label="$t('page.createResource.configuration.labels.resourceType')"
      >
        <b-form-input
          readonly
          :disabled="true"
          :model-value="
            selectedResourceTypeInformation?.specificType
              ? $t(
                  'resourceTypes.' +
                    selectedResourceTypeInformation.specificType +
                    '.displayName',
                )
              : $t('resourceTypes.resource')
          "
        />
      </CoscineFormGroup>

      <CoscineFormGroup
        v-if="resourceForCreation && resourceForCreation.resourceTypeOptions"
        :mandatory="true"
        :label="$t('page.createResource.configuration.labels.size')"
      >
        <b-form-input
          readonly
          :disabled="true"
          :model-value="resourceSizeText"
        />
      </CoscineFormGroup>
    </b-card>

    <!-- Resource Metadata Information -->
    <b-card class="my-2">
      <b-link class="float-end text-primary" @click.prevent="toTab(tabs[1])">
        {{ $t("page.createResource.overview.edit") }}
      </b-link>
      <CoscineHeadline :headline="$t('form.steps.second')" h="h5" />

      <!-- Resource Metadata -->
      <ResourceMetadata v-model="resourceForCreation" :readonly="true" />
    </b-card>

    <!-- Application Profile -->
    <b-card class="my-2 p-0">
      <b-link class="float-end text-primary" @click.prevent="toTab(tabs[2])">
        {{ $t("page.createResource.overview.edit") }}
      </b-link>
      <CoscineHeadline :headline="$t('form.steps.third')" h="h5" />

      <!-- Form Generator -->
      <b-row v-if="isLoadingFormGenerator" align-h="center" class="my-2">
        <b-spinner variant="primary" />
      </b-row>
      <FormGenerator
        v-else
        :key="resourceForCreation.applicationProfile?.uri"
        :fixed-value-mode="fixedValueMode"
        :fixed-values="fixedValues"
        :locale="$i18n.locale"
        :disabled-mode="true"
        :selected-shape="resourceForCreation.applicationProfile?.uri"
        :shapes="applicationProfile"
        :class-receiver="getVocabularyInstances"
        :instance-receiver="getVocabularyInstance"
        :user-receiver="async () => user"
        shape-mime-type="application/ld+json"
      />
    </b-card>

    <!-- Buttons -->
    <b-form-group>
      <!-- Button Back -->
      <b-button variant="outline-primary" @click.prevent="back">
        {{ $t("buttons.back") }}
      </b-button>

      <!-- Button Confirm -->
      <b-button
        :disabled="isUploadInProgress || isLoadingFormGenerator"
        class="float-end"
        variant="outline-primary"
        @click.prevent="clickSave"
      >
        {{ $t("buttons.confirm") }}
      </b-button>
    </b-form-group>
  </div>
</template>

<script lang="ts" setup>
// import the store for current module
import useResourceStore from "@/modules/resource/store";
import useProjectStore from "@/modules/project/store";
import useUserStore from "@/modules/user/store";
import ResourceMetadata from "./ResourceMetadata.vue";
import { navigateToProject } from "@/router";
import type { Dataset } from "@rdfjs/types";
import {
  type BilingualLabels,
  QuotaUnit,
  type ResourceCreationTab,
  type BilingualLabel,
} from "../../types";
import useNotificationStore from "@/store/notification";
import type {
  QuotaForManipulationDto,
  ResourceForCreationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import { FileUtil } from "../../utils/FileUtil";
import type { FixedValues } from "@coscine/form-generator/dist/types/fixedValues";

import { useI18n } from "vue-i18n";
const i18n = useI18n();

const resourceForCreation = defineModel<ResourceForCreationDto>({
  required: true,
});

defineProps({
  tabs: {
    type: Array as PropType<ResourceCreationTab[]>,
    required: true,
  },
  applicationProfile: {
    type: [Object, null] as PropType<Dataset | null>,
    default: null,
  },
  isLoadingFormGenerator: {
    type: Boolean,
    required: true,
  },
});

const emit = defineEmits<{
  back: [];
  toTab: [_: ResourceCreationTab];
  waitingForResponse: [_: boolean];
}>();

const projectStore = useProjectStore();
const resourceStore = useResourceStore();
const userStore = useUserStore();
const notificationStore = useNotificationStore();

const fixedValueMode = ref(true);
const isUploadInProgress = ref(false);

const project = computed(() => {
  return projectStore.currentProject;
});
const selectedResourceTypeInformation = computed(() => {
  return resourceStore.enabledResourceTypes?.find(
    (rt) => rt.id === resourceForCreation.value.resourceTypeId,
  );
});
const user = computed(() => {
  return userStore.user ?? { displayName: undefined };
});
const resourceSizeText = computed(() => {
  if (
    resourceForCreation.value.resourceTypeOptions?.rdsResourceTypeOptions?.quota
  ) {
    return i18n
      .t("default.gb", {
        number: toGiB(
          resourceForCreation.value.resourceTypeOptions?.rdsResourceTypeOptions
            ?.quota,
        ),
      })
      .toString();
  } else if (
    resourceForCreation.value.resourceTypeOptions?.rdsS3ResourceTypeOptions
      ?.quota
  ) {
    return i18n
      .t("default.gb", {
        number: toGiB(
          resourceForCreation.value.resourceTypeOptions
            ?.rdsS3ResourceTypeOptions?.quota,
        ),
      })
      .toString();
  } else if (
    resourceForCreation.value.resourceTypeOptions?.rdsS3WormResourceTypeOptions
      ?.quota
  ) {
    return i18n
      .t("default.gb", {
        number: toGiB(
          resourceForCreation.value.resourceTypeOptions
            ?.rdsS3WormResourceTypeOptions?.quota,
        ),
      })
      .toString();
  } else {
    return i18n.t("default.none").toString();
  }
});
const fixedValues = computed(() => {
  return resourceForCreation.value.fixedValues as FixedValues;
});

/**
 * Fetches vocabulary instance from the store.
 */
const getVocabularyInstance = async (
  instanceUrl: string,
): Promise<BilingualLabel> => {
  return await resourceStore.getVocabularyInstance(instanceUrl);
};

/**
 * Fetches vocabulary instances for a given class name from the store.
 *
 * @async
 * @param {string} className - The class name for which vocabulary instances need to be fetched.
 * @param {number} pageNumber - The pageNumber for retrieving the correct page of files.
 * @param {number} pageSize - The pageSize for retrieving the correct size of the files.
 * @returns {Promise<BilingualLabels>} Returns a promise resolving to bilingual labels.
 */
const getVocabularyInstances = async (
  className: string,
  pageNumber: number,
  pageSize: number,
  searchTerm?: string | undefined,
): Promise<BilingualLabels> => {
  return await resourceStore.getVocabularyInstances(
    className,
    pageNumber,
    pageSize,
    searchTerm,
  );
};

/**
 * Converts a quota value to GiB (Gibibytes).
 * @param quota - The quota to be converted.
 * @returns {number} - The quota value in GiB.
 */
const toGiB = (quota: QuotaForManipulationDto): number => {
  // Almost all displayed values inside the html must be shown in GiB, making this method necessary to ensure that's always the case.
  return FileUtil.convertCapacityUnits(quota, QuotaUnit.GibiByte);
};

const back = () => {
  emit("back");
};

const toTab = (tab: ResourceCreationTab) => {
  emit("toTab", tab);
};

const clickSave = async () => {
  if (project.value) {
    emit("waitingForResponse", true);
    isUploadInProgress.value = true;
    const createdResource = await resourceStore.createResourceForProject(
      project.value,
      resourceForCreation.value,
    );

    if (createdResource) {
      // On Success
      // Refresh the project information in the store
      await projectStore.refreshProjectInformation(project.value);
      // Navigate inside the parent project
      navigateToProject(project.value);
    } else {
      emit("waitingForResponse", false);
      // On Failure
      notificationStore.postNotification({
        title: i18n.t("toast.onSave.failure.title").toString(),
        body: i18n.t("toast.onSave.failure.message").toString(),
        variant: "danger",
      });
    }

    isUploadInProgress.value = false;
  }
};
</script>
